#
# spec file for package ffmpeg
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           ffmpeg
Version:        2.6.2
Release:        2
Summary:        Library working with various multimedia formats
License:        LGPL-2.1+ and GPL-2.0+
Group:          Productivity/Multimedia/Video/Editors and Convertors
Url:            https://ffmpeg.org/

#Freshcode-URL:	http://freshcode.club/projects/ffmpeg
#Git-Clone:	git://source.ffmpeg.org/ffmpeg
Source:         https://www.ffmpeg.org/releases/%name-%version.tar.bz2
Source2:        https://www.ffmpeg.org/releases/%name-%version.tar.bz2.asc
Patch1:         ffmpeg-pkgconfig-requires.diff
#BuildRequires:  libgsm-devel
#BuildRequires:  pkg-config
BuildRequires:  yasm
BuildRequires:  pkgconfig(alsa)
#BuildRequires:  pkgconfig(bzip2)
BuildRequires:  pkgconfig(freetype2)
#BuildRequires:  pkgconfig(frei0r)
BuildRequires:  pkgconfig(gnutls)
BuildRequires:  pkgconfig(jack)
BuildRequires:  pkgconfig(libcdio_paranoia)
BuildRequires:  pkgconfig(libdc1394-2)
#BuildRequires:  pkgconfig(libopenjpeg)
BuildRequires:  pkgconfig(libpulse)
BuildRequires:  pkgconfig(libraw1394)
BuildRequires:  pkgconfig(libva)
BuildRequires:  pkgconfig(opus)
BuildRequires:  pkgconfig(schroedinger-1.0)
BuildRequires:  pkgconfig(sdl)
BuildRequires:  pkgconfig(speex)
BuildRequires:  pkgconfig(theora)
BuildRequires:  pkgconfig(vdpau)
BuildRequires:  pkgconfig(vorbis)
BuildRequires:  pkgconfig(vpx)
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(xext)
BuildRequires:  pkgconfig(xfixes)
BuildRequires:  pkgconfig(zlib)
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
FFmpeg is the leading multimedia framework, able to decode, encode,
transcode, mux, demux, stream, filter and play pretty much anything
that humans and machines have created. It supports the most obscure
ancient formats up to the cutting edge. No matter if they were
designed by some standards committee, the community or a corporation.

%package -n libavcodec56
Summary:        FFmpeg codec library
Group:          System/Libraries

%description -n libavcodec56
The libavcodec library provides a generic encoding/decoding framework
and contains multiple decoders and encoders for audio, video and
subtitle streams, and several bitstream filters.

The shared architecture provides various services ranging from bit
stream I/O to DSP optimizations, and makes it suitable for
implementing robust and fast codecs as well as for experimentation.

%package -n libavcodec-devel
Summary:        Development files for FFmpeg's codec library
Group:          Development/Libraries/C and C++
Requires:       libavcodec56 = %version

%description -n libavcodec-devel
The libavcodec library provides a generic encoding/decoding framework
and contains multiple decoders and encoders for audio, video and
subtitle streams, and several bitstream filters.

This subpackage contains the headers for FFmpeg libavcodec.

%package -n libavdevice56
Summary:        FFmpeg device library
Group:          System/Libraries

%description -n libavdevice56
The libavdevice library provides a generic framework for grabbing from
and rendering to many common multimedia input/output devices, and
supports several input and output devices, including Video4Linux2, VfW,
DShow, and ALSA.

%package -n libavdevice-devel
Summary:        Development files for FFmpeg's device library
Group:          Development/Libraries/C and C++
Requires:       libavdevice56 = %version

%description -n libavdevice-devel
The libavdevice library provides a generic framework for grabbing from
and rendering to many common multimedia input/output devices, and
supports several input and output devices, including Video4Linux2, VfW,
DShow, and ALSA.

This subpackage contains the headers for FFmpeg libavcodec.

%package -n libavfilter5
Summary:        FFmpeg audio and video filtering library
Group:          System/Libraries

%description -n libavfilter5
The libavfilter library provides a generic audio/video filtering
framework containing several filters, sources and sinks.

%package -n libavfilter-devel
Summary:        Development files for FFmpeg's audio/video filter library
Group:          Development/Libraries/C and C++
Requires:       libavfilter5 = %version

%description -n libavfilter-devel
The libavfilter library provides a generic audio/video filtering
framework containing several filters, sources and sinks.

This subpackage contains the headers for FFmpeg libavcodec.

%package -n libavformat56
Summary:        FFmpeg's stream format library
Group:          System/Libraries

%description -n libavformat56
The libavformat library provides a generic framework for multiplexing
and demultiplexing (muxing and demuxing) audio, video and subtitle
streams. It encompasses multiple muxers and demuxers for multimedia
container formats.

%package -n libavformat-devel
Summary:        Development files for FFmpeg's stream format library
Group:          Development/Libraries/C and C++
Requires:       libavformat56 = %version

%description -n libavformat-devel
The libavformat library provides a generic framework for multiplexing
and demultiplexing (muxing and demuxing) audio, video and subtitle
streams. It encompasses multiple muxers and demuxers for multimedia
container formats.

This subpackage contains the headers for FFmpeg libavcodec.

%package -n libavutil54
Summary:        FFmpeg's utility library
Group:          System/Libraries

%description -n libavutil54
The libavutil library is a utility library to aid portable multimedia
programming. It contains safe portable string functions, random
number generators, data structures, additional mathematics functions,
cryptography and multimedia related functionality (like enumerations
for pixel and sample formats).

%package -n libavutil-devel
Summary:        Development files for FFmpeg's utility library
Group:          Development/Libraries/C and C++
Requires:       libavutil54 = %version

%description -n libavutil-devel
The libavutil library is a utility library to aid portable multimedia
programming. It contains safe portable string functions, random
number generators, data structures, additional mathematics functions,
cryptography and multimedia related functionality (like enumerations
for pixel and sample formats).

This subpackage contains the headers for FFmpeg libavcodec.

%package -n libpostproc53
Summary:        FFmpeg post-processing library
Group:          System/Libraries

%description -n libpostproc53
A library with video postprocessing filters, such as deblocking and
deringing filters, noise reduction, automatic contrast and brightness
correction, linear/cubic interpolating deinterlacing.

%package -n libpostproc-devel
Summary:        Development files for the FFmpeg post-processing library
Group:          Development/Libraries/C and C++
Requires:       libpostproc53 = %version

%description -n libpostproc-devel
A library with video postprocessing filters, such as deblocking and
deringing filters, noise reduction, automatic contrast and brightness
correction, linear/cubic interpolating deinterlacing.

This subpackage contains the headers for FFmpeg libavcodec.

%package -n libswresample1
Summary:        FFmpeg software resampling library
Group:          System/Libraries

%description -n libswresample1
The libswresample library performs audio resampling, rematrixing and
sample format conversion operations.

%package -n libswresample-devel
Summary:        Development files for the FFmpeg software resampling library
Group:          Development/Libraries/C and C++
Requires:       libswresample1 = %version

%description -n libswresample-devel
This subpackage contains the headers for FFmpeg libavcodec.

%package -n libswscale3
Summary:        FFmpeg image scaling and colorspace/pixel conversion library
Group:          System/Libraries

%description -n libswscale3
The libswscale library performs image scaling and colorspace and
pixel format conversion operations.

%package -n libswscale-devel
Summary:        Development files for FFmpeg's image scaling and colorspace library
Group:          Development/Libraries/C and C++
Requires:       libswscale3 = %version

%description -n libswscale-devel
The libswscale library performs image scaling and colorspace and
pixel format conversion operations.

This subpackage contains the headers for FFmpeg libswscale.

%package devel
Summary:        Development files for FFmpeg
Group:          Development/Libraries/C and C++
Requires:       libavcodec-devel = %version
Requires:       libavdevice-devel = %version
Requires:       libavfilter-devel = %version
Requires:       libavformat-devel = %version
Requires:       libavutil-devel = %version
Requires:       libpostproc-devel = %version
Requires:       libswresample-devel = %version
Requires:       libswscale-devel = %version

%description devel
FFmpeg consists of a number of C libraries that work with various
multimedia formats.

This metapackage will pull them all in.

%prep
%setup -q
%patch -P 1 -p1

%build
perl -i -pe 's{__TIME__|__DATE__}{"$&"}g' *.c

# There is no need to change the symbol versions (*.v files), because the
# SONAME is already changed.
#
# For future reviews, check the configure output and review the enabled
# muxers and so on to ensure the enable list is up-to-date

#	--enable-frei0r \
#	--enable-libgsm \
#	--enable-libopenjpeg \

CFLAGS="%optflags" \
./configure \
	--prefix="%_prefix" --libdir="%_libdir" --shlibdir="%_libdir" \
	--incdir="%_includedir/ffmpeg" \
	--extra-cflags="%optflags" --optflags="%optflags" \
	--enable-pic --disable-stripping \
	--enable-shared --disable-static \
	--enable-runtime-cpudetect \
	--enable-gpl \
	--disable-openssl \
	--enable-gnutls \
	--enable-libcdio \
	--enable-libdc1394 \
	--enable-libfreetype \
	--enable-libopus \
	--enable-libpulse \
	--enable-libschroedinger \
	--enable-libspeex \
	--enable-libtheora \
	--enable-libvorbis \
	--enable-libvpx \
	--enable-pic \
	--enable-pthreads \
	--enable-vaapi \
	--enable-vdpau \
	--enable-x11grab \
%if !0%{?BUILD_ORIG}
	--disable-encoders \
	--disable-decoders \
	--disable-muxers \
	--disable-demuxers \
	--enable-encoder="flac,gif,jpegls,libopenjpeg,libtheora,libvorbis,libvpx,png" \
	--enable-decoder="flac,gif,jpegls,ljpeg,libopenjpeg,libtheora,libvpx,png,vorbis,vp3,vp5,vp6,vp6a,vp6f,vp8,vp9,webp" \
	--enable-muxer="flac,gif,image2,image2pipe,matroska,matroska_audio,null,webm" \
	--enable-demuxer="flac,gif,image2,image2pipe,matroska"
%endif
make %{?_smp_mflags}

%global extratools aviocat graph2dot ismindex pktdumper qt-faststart trasher cws2fws
for i in %extratools; do
	make "tools/$i"
done

%install
b="%buildroot"
%make_install install-man
rm -Rf "$b/%_datadir/ffmpeg/examples"
for i in %extratools; do
	cp -a "tools/$i" "$b/%_bindir/"
done

%post   -n libavcodec56 -p /sbin/ldconfig
%postun -n libavcodec56 -p /sbin/ldconfig
%post   -n libavdevice56 -p /sbin/ldconfig
%postun -n libavdevice56 -p /sbin/ldconfig
%post   -n libavfilter5 -p /sbin/ldconfig
%postun -n libavfilter5 -p /sbin/ldconfig
%post   -n libavformat56 -p /sbin/ldconfig
%postun -n libavformat56 -p /sbin/ldconfig
%post   -n libavutil54 -p /sbin/ldconfig
%postun -n libavutil54 -p /sbin/ldconfig
%post   -n libpostproc53 -p /sbin/ldconfig
%postun -n libpostproc53 -p /sbin/ldconfig
%post   -n libswresample1 -p /sbin/ldconfig
%postun -n libswresample1 -p /sbin/ldconfig
%post   -n libswscale3 -p /sbin/ldconfig
%postun -n libswscale3 -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc Changelog COPYING.GPLv2 CREDITS LICENSE.md README.md
%_bindir/*
%_mandir/man1/ff*.1*
%_datadir/ffmpeg/

%files -n libavcodec56
%defattr(-,root,root)
%_libdir/libavcodec.so.*

%files -n libavdevice56
%defattr(-,root,root)
%_libdir/libavdevice.so.*

%files -n libavfilter5
%defattr(-,root,root)
%_libdir/libavfilter.so.*

%files -n libavformat56
%defattr(-,root,root)
%_libdir/libavformat.so.*

%files -n libavutil54
%defattr(-,root,root)
%_libdir/libavutil.so.*

%files -n libpostproc53
%defattr(-,root,root)
%_libdir/libpostproc.so.*

%files -n libswresample1
%defattr(-,root,root)
%_libdir/libswresample.so.*

%files -n libswscale3
%defattr(-,root,root)
%_libdir/libswscale.so.*

%files -n libavcodec-devel
%defattr(-,root,root)
%dir %_includedir/ffmpeg/
%_includedir/ffmpeg/libavcodec/
%_libdir/libavcodec.so
%_libdir/pkgconfig/libavcodec.pc
%_mandir/man3/libavcodec.3*

%files -n libavdevice-devel
%defattr(-,root,root)
%dir %_includedir/ffmpeg/
%_includedir/ffmpeg/libavdevice/
%_libdir/libavdevice.so
%_libdir/pkgconfig/libavdevice.pc
%_mandir/man3/libavdevice.3*

%files -n libavfilter-devel
%defattr(-,root,root)
%dir %_includedir/ffmpeg/
%_includedir/ffmpeg/libavfilter/
%_libdir/libavfilter.so
%_libdir/pkgconfig/libavfilter.pc
%_mandir/man3/libavfilter.3*

%files -n libavformat-devel
%defattr(-,root,root)
%dir %_includedir/ffmpeg/
%_includedir/ffmpeg/libavformat/
%_libdir/libavformat.so
%_libdir/pkgconfig/libavformat.pc
%_mandir/man3/libavformat.3*

%files -n libavutil-devel
%defattr(-,root,root)
%dir %_includedir/ffmpeg/
%_includedir/ffmpeg/libavutil/
%_libdir/libavutil.so
%_libdir/pkgconfig/libavutil.pc
%_mandir/man3/libavutil.3*

%files -n libpostproc-devel
%defattr(-,root,root)
%dir %_includedir/ffmpeg/
%_includedir/ffmpeg/libpostproc/
%_libdir/libpostproc.so
%_libdir/pkgconfig/libpostproc.pc

%files -n libswresample-devel
%defattr(-,root,root)
%dir %_includedir/ffmpeg/
%_includedir/ffmpeg/libswresample/
%_libdir/libswresample.so
%_libdir/pkgconfig/libswresample.pc
%_mandir/man3/libswresample.3*

%files -n libswscale-devel
%defattr(-,root,root)
%dir %_includedir/ffmpeg/
%_includedir/ffmpeg/libswscale/
%_libdir/libswscale.so
%_libdir/pkgconfig/libswscale.pc
%_mandir/man3/libswscale.3*

%files devel
%defattr(-,root,root)
%dir %_includedir/ffmpeg/

%changelog
* Sat May 09 2015 josef radinger <cheese@nosuchhost.net> - 2.6.2-1
- bump version
- fresh rebuild
- disable buildrequires on libgsm-devel
- disable buildrequires on pkg-config
- disable buildrequires on pkgconfig(bzip2)
- disable buildrequires on pkgconfig(frei0r)
- disable buildrequires on pkgconfig(libopenjpeg)

* Mon Apr 13 2015 jengelh@inai.de
- Update to new upstream release 2.6.2
  * avformat/utils: avoid discarded streams in
  av_find_default_stream_index()
  * avutil/cpu: add missing check for mmxext to av_force_cpu_flags
  * avformat/http: replace cookies with updated values instead of
  appending forever
* Thu Mar 19 2015 jengelh@inai.de
- Update to new upstream release 2.6.1
  * Maintenance release with some bugfixes
* Sun Mar  8 2015 jengelh@inai.de
- Update to new upstream release 2.6
  * The VP9 decoder is now usable on x86(-32) and pre-SSSE3 CPUs.
  * 10-bit support in the SPP video filter
  * New video filters: "colorlevels", "tblend", "palettegen",
  "paletteuse". New audio filters: "dcshift".
  * The old libmpcodecs wrapper is finally gone
  * API changes: introduction of device inputs and outputs
* Tue Jan 27 2015 jengelh@inai.de
- Update to new upstream release 2.5.3
  * AVFoundation screen-grabbing support, animated WebP decoding
  support, and Animated PNG support. UDP-Lite support was added.
* Sun Jan  4 2015 jengelh@inai.de
- Initial package (version 2.5.3) for build.opensuse.org
